# Visualization Library

A lightweight C++ OpenGL middleware for 2D/3D graphics

[Home] [Tutorials] [All Classes] [Grouped Classes]

Public Member Functions | Protected Attributes

# vl::SceneManagerBVH< T > Class Template Reference

The SceneManagerBVH class implements the basic functionalities for bounding-volume-hierarchy based scene managers. More...

`#include <SceneManagerBVH.hpp>`

Inheritance diagram for vl::SceneManagerBVH< T >:

List of all members.

## Public Member Functions

virtual const char * | className ()
| Returns the name of the class.
void | setTree (T *bbh)
| Sets the tree to be used by the scene manager.
const T * | tree () const
| Returns the tree used by the scene manager.
T * | tree ()
| Returns the tree used by the scene manager.
virtual void | extractVisibleActors (ActorCollection &list, const Camera *camera)
| Performs frustum culling and appends the enabled and visible Actor[s] to the given ActorCollection.
virtual void | extractActors (ActorCollection &list)
| Appends all the Actor[s] contained in the scene manager without performing frustum culling or checking enable masks.

## Protected Attributes

ref< T > | mBoundingVolumeTree

## Detailed Description

### template<class T>
class vl::SceneManagerBVH< T >

The SceneManagerBVH class implements the basic functionalities for bounding-volume-hierarchy based scene managers.

See also:
  - Actor
  - ActorKdTree
  - ActorTree
  - SceneManager
  - SceneManagerActorKdTree
  - SceneManagerActorTree
  - SceneManagerPortals

Definition at line 55 of file SceneManagerBVH.hpp.

## Member Function Documentation

template<class T>

virtual const char* vl::SceneManagerBVH< T >::className | ( | ) | `[inline, virtual]`

Returns the name of the class.

Reimplemented from vl::SceneManager.

Reimplemented in vl::SceneManagerActorKdTree, vl::SceneManagerActorTree, and vl::Terrain.

Definition at line 58 of file SceneManagerBVH.hpp.

template<class T>

void vl::SceneManagerBVH< T >::setTree | ( | T * | bbh ) | `[inline]`

Sets the tree to be used by the scene manager.

Definition at line 61 of file SceneManagerBVH.hpp.

template<class T>

const T* vl::SceneManagerBVH< T >::tree | ( | ) | const`[inline]`

Returns the tree used by the scene manager.

Definition at line 63 of file SceneManagerBVH.hpp.

template<class T>

T* vl::SceneManagerBVH< T >::tree | ( | ) | `[inline]`

Returns the tree used by the scene manager.

Definition at line 65 of file SceneManagerBVH.hpp.

template<class T>

virtual void vl::SceneManagerBVH< T >::extractVisibleActors | ( | ActorCollection & | list,
|  | const Camera * | camera
| ) |  | `[inline, virtual]`

Performs frustum culling and appends the enabled and visible Actor[s] to the given ActorCollection.

See also enableMask(), Actor::enableMask()

Implements vl::SceneManager.

Definition at line 67 of file SceneManagerBVH.hpp.

template<class T>

virtual void vl::SceneManagerBVH< T >::extractActors | ( | ActorCollection & | list ) | `[inline, virtual]`

Appends all the Actor[s] contained in the scene manager without performing frustum culling or checking enable masks.

Implements vl::SceneManager.

Definition at line 76 of file SceneManagerBVH.hpp.

## Member Data Documentation

template<class T>

ref<T> vl::SceneManagerBVH< T >::mBoundingVolumeTree`[protected]`

Definition at line 83 of file SceneManagerBVH.hpp.

The documentation for this class was generated from the following file:

- D:/VL/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGraphics/SceneManagerBVH.hpp

Visualization Library v2011.05.1142 Reference Documentation
Copyright 2005-2011 Michele Bosi. All rights reserved.
Updated on Thu May 26 2011 22:51:45.
Permission is granted to use this page to write and publish articles regarding Visualization Library.